local myName, ns = ...

local enabled, hooked

local function update()
    if Bagnon.sets then
        -- SyLevel is... enthusiastic.
        Bagnon:UpdateFrames()
    end
end

local update_slot = function(self)
    local icon, count, locked, quality, readable, lootable, link = self:GetInfo()
    SyLevel:CallFilters('Bagnon', self, enabled and link)
end

local function enable()
    enabled = true
    if not hooked then
        hooksecurefunc(Bagnon.ItemSlot, "Update", update_slot)
        hooked = true
    end
    update()
end

local function disable()
    enabled = false
    update()
end

local f = CreateFrame("Frame")
f:SetScript("OnEvent", function(self, event, addon_name)
    if addon_name ~= myName then return end
    SyLevel:RegisterPipe('Bagnon', enable, disable, update, 'Bagnon')

    -- call register again to apply saved var settings
    -- this is required since we're loaded after SyLevel
    SyLevel:RegisterAllPipesAndFilters()

    self:UnregisterEvent("ADDON_LOADED")
    self:SetScript("OnEvent", nil)
end)
f:RegisterEvent("ADDON_LOADED")
